
import de.cardcontact.jni2ctapi.cardterminal_api;

public class test_ctapi
{


    public static void main(String[] args)
    {
        
        byte[] rsp = new byte[100];
        
        int i;
        int lr = 0;

        byte[] resetICC = {0x20, 0x11, 0x01, 0x01, 0x00};
        byte[] ejectICC = {0x20, 0x15, 0x00, 0x00, 0x00};

        int[] verifyPin = {0xa0, 0x20, 0x00, 0x01, 0x08,(byte) '4',(byte) '9',(byte) '6',(byte) '1', 0xff, 0xff, 0xff, 0xff};
        int[] selectMF = {0xa0,0xa4,0x00,0x00,0x02,0x3f,0x00};
        int[] selectDFTelecom = {0xa0,0xa4,0x00,0x00,0x02,0x7f,0x10};
        int[] selectDFGSM = {0xa0,0xa4,0x00,0x00,0x02,0x7f,0x20};
        int[] selectEFbcch = {0xa0,0xa4,0x00,0x00,0x02,0x6f,0x74};
        int[] selectEFADN = {0xa0,0xa4,0x00,0x00,0x02,0x6f,0x3a};
        int[] selectEFIccID = {0xa0,0xa4,0x00,0x00,0x02,0x2f,0xe2};
        int[] getResponse = {0xa0,0xc0,0x00,0x00, 0x16};
        int[] readRecord = {0xa0,0xb2,0x01,0x04, 0x20};
        int[] readBinary = {0xa0,0xb0,0x00,0x00, 0x15};
        int[] seek = {0xa0,0xa2,0x00,0x00,0x00,0x20};

        try {
            cardterminal_api reader = new cardterminal_api("cteco5000");
        
        
        int rc = reader.CT_Init((char)1, (char)1);

        if(rc < 0) {
            System.out.println("Error opening CT!");
            System.exit(1);
        }
        else
            System.out.println("Success: CT_Init");


        for(i=0;i < rsp.length;i++)
            rsp[i] = 0;

        lr = rsp.length;
        rc = reader.CT_Data((char) 1, (byte)1, (byte)2, 5, (byte[])resetICC, (char) lr, rsp);
        
        if(rc < 0) {
            System.out.println("Error sending DATA! rc = " + rc);
            System.exit(1);
        }       
        else { 
            System.out.println("Success: CT_Data");
            // System.out.println(HexString.dump(rsp, 0, rc));
            System.out.println("lr = "+ rc);
        }

        if(rsp[rc-2] == 0x64)
            {
                System.out.println("No ICC present!!");
                System.exit(1);
            }

        for(i=0;i < rsp.length;i++)
            rsp[i] = 0;

        lr = rsp.length;
        rc = reader.CT_Data((char) 1, (byte)0, (byte)2, 7, createByteArray(selectMF), (char) lr, rsp);
        
        if(rc < 0)
            System.out.println("Error sending DATA! rc = " + rc);
        else { 
            System.out.println("Success: CT_Data");
            // System.out.println(HexString.dump(rsp, 0, rc));
            System.out.println("lr = "+ rc);
        }
        
        for(i=0;i < rsp.length;i++)
            rsp[i] = 0;
        lr = rsp.length;
        
        rc = reader.CT_Data((char) 1, (byte)1, (byte)2, 5, ejectICC, (char) lr, rsp);
        
        if(rc < 0)
            System.out.println("Error sending DATA! rc = " + rc);
        else { 
            System.out.println("Success: CT_Data");
            // System.out.println(HexString.dump(rsp, 0, rc));
            System.out.println("lr = "+ rc);
        }


        rc = reader.CT_Close((char)1);
        
        if(rc < 0)
            System.out.println("Error closing CT!");
        else
            System.out.println("Success: CT_Close");
        

        }

        catch(UnsatisfiedLinkError e)
            {
                System.out.println(e.toString());
                System.exit(1);
            }
    }

    public static byte [] createByteArray (int [] para)
    {
        int i;
        
        byte [] cmd = new byte[255];
        
        for(i=0; i < para.length; i++)
            cmd[i] = (byte) para[i];
        
        return cmd;
        
    }

}
